# Template Deep Dive

⚠️ This section is a deep dive into the contents of the files of a "Hello, World" project,
specifically written for people who are not that familiar with Rust. If you'd rather just
checkout the workflow, feel free to skip this section!

⚠️ If you haven't used a template to set up your project, the contents of your files
may look slightly different than what is described here.

### What the Template Gave Us

Let's start by taking a look at what the template generated for us.

- [`Cargo.toml` - the Cargo manifest](./cargo-toml.html)
- [`src/lib.rs` - main library module](./src-lib-rs.html)
- [`src/utils.rs` - a utility module](./src-utils-rs.html)
- [`wee_alloc` - a tiny memory allocator](./wee_alloc.html)
- [`tests/web.rs` - running headless browser tests](./tests-web-rs.html)
